;
; CONTROLLO ROTORI ANTENNA CON IL PROGRAMMA INSTANTRACK
;    VERSIONE 1.0     CON SCHEDA DI NE.
;-------------------------------------------------------------
code 1   segment public
        org 100h
        assume cs:code, ds:code, es:code
start:

       MOV     DX,011Ch                   ; nouvo vettore 63h
       MOV     AX,2563h                   ; setta via dos
       INT     21h                        ; chiama il dos
       MOV     DX,0250h                   ; residente
       ADD     DX,+0Fh                    ;
       MOV     CL,04h                     ;
       SHR     DX,CL                      ;
       MOV     AX,3100h                   ;
       INT     21h                        ; torna al prompth dos
       DB      1                          ; zona flags per settaggio da
       DW      0,0                        ; salva azimut ed elevazione
       JMP     num1                       ; punto di entrata INT
       DW      0,0                        ; posizioni vuote byte di settaggio
       DB      0,0,0                      ; non utilizzate
       DB      "RotorDRV"                 ; posizionamento stringa in RAM
num1:  STI                                ; disabilita INT
       CMP     AH,00                      ; controllo flags
       JZ      num2                       ;
       CMP     AH,03h                     ; test su AH
       JZ      num3                       ; se AH = 03h salta
       CMP     AH,04                      ;
       JZ      num4                       ;
       CMP     AH,09h                     ;
       JZ      num5                       ;
       IRET                               ; ritorno  se nessuna condizione
num2:  MOV     AL,00                      ; se AH=0 pone AL =0
       IRET                               ; ritorno
num3:  MOV     AX,CS:[011Ah]              ; se AH=3
       MOV     CX,AX                      ; pone in CX= elevazione
       MOV     BX,CS:[0118h]              ; legge  valore elevazione salvato
       MOV     DX,BX                      ; pone in DX azimut
       IRET                               ; ritorna
num4:  CMP     BYTE PTR CS:[0117h],00     ; Testa  il byte 01 in 0117h
       JZ      num6                       ; se 0 salta  uscita
       PUSHF                              ; salva i flag
       CALL scomm                         ; chiamata azimut
       CALL scomm1                        ; chiamata elevazione
       MOV     AX,0B800h                  ; inizio area video
       MOV     ES,AX                      ; salva in ES segmento video
       MOV     DI,008Ch                   ; posizione video rig 1 col 70
       PUSH    DX                         ; salva DX
       MOV     CS:[0118h],DX              ; salva  azimuth in 0118h
       PUSH    CX                         ;
       MOV     CS:[011Ah],CX              ; salva  elevazione in 011Ah
       MOV     CX,000Ah                   ; ripete 10 volte
       CLD                                ;
       MOV     AX,0720h                   ; scrive a video 10 spazii
       REPZ    STOSW                      ; ripete finche' CX=0
       MOV     DI,009Eh                   ;
       STD                                ;
       POP     CX                         ; riprende elevazione
       CALL    num7                       ;
       DEC     DI                         ;
       DEC     DI                         ;
       POP     CX                         ;
       CALL    num7                       ;
       POPF                               ;

num6:  IRET                               ;
num7:  MOV     SI,0000                    ;
       MOV     AX,CX                      ;
       AND     AX,AX                      ;
       JGE     num8                       ;
       NEG     AX                         ;
       INC     SI                         ;
num8:  MOV     DX,0000                    ;
       MOV     BX,000Ah                   ;
       DIV     BX                         ;
       MOV     CX,AX                      ;
       MOV     AX,DX                      ;
       ADD     AX,0730h                   ;
       STOSW                              ;
       MOV     AX,CX                      ;
       AND     AX,AX                      ;
       JNZ     num8                       ;
       AND     SI,SI                      ;
       JZ      num9                       ;
       MOV     AX,072Dh                   ;
       STOSW                              ;
num9:  RET                                ;
num5:  MOV     CS:[0117h],AL              ;
       IRET                               ;

;----------  uscita su porta parallela  0309h    azimut   ------

                               ; oldaz definito dw = 0 ad inizio programma
                               ; oldel definito dw = 0 ad inizio programma
scomm   proc near
        push cx                ; salva   cx
        push dx                ; salva   dx
        cmp  cx,0000h          ; confronta cx con 0
        jle stopaz             ; se minore o uguale salta
        mov ax,dx              ; dx = valore  in gradi Azimut
        mov cx,CS:oldaz        ; carica in cx  AZIMUT  precedente
        sub ax,cx              ; sottrae       AZIMUT  attuale
        jnc salto              ; salta  se minore di OLDAZ
        neg ax                 ; cambia segno se negativo
salto:  cmp ax,1               ; confronta con offset stabilito (2 gradi)
        jle uscita             ; se minore o uguale salta a USCITA
        mov ax,dx              ; carica il nuovo AZIMUT in ax dal reg dx
        mov CS:oldaz,ax        ; salva  il valore in OLDAZIMUT
                               ; ------------------------------------------!
                               ; togliere per rotori con blocco a nord     !
;       add ax,0b4h            ; addiziona 180 gradi  (blocco a sud)       !
        cmp ax,0168h           ; confronta  se > 360 gradi                 !
        jl  minore             ; se < salta                                !
        sub ax,0168h           ; sottrae 360 se > di 360 gradi             !
 minore:                       ;-------------------------------------------!
        mov cx,020h            ; carica in cx 32 decimale
        mul cx                 ; moltiplica ax per cx
        mov dx,0               ; azzera registro dx
        mov cx,02Dh            ; carica in cx coefficente 360/256
        div cx                 ; divide ax  per  cx
 ;      sub  ax,02h
        mov dx,0309h           ; carica in dx indirizzo della porta
        out dx,al              ; manda il dato  alla porta
        jmp uscita

stopaz: mov  ax,07Fh           ; carica in ax 124 dec ( 180 gradi)
        mov  dx,0309h          ; indirizzo porta azimut
        out  dx,al             ; porta l'antenna nella posizione centrale

uscita: pop dx                 ; pesca dx
        pop cx                 ; pesca cx
        ret                    ; ritorno
scomm   endp
;------------ uscita su  porta parallela 0308h      elevazione  ------------
scomm1  proc near
        push cx                ; salva cx
        push dx                ; salva dx
        mov ax,cx              ; in ax il valore ELEVAZ
        cmp  ax,0000h          ; confronta  ax con 0
        jle  stopel            ; se minore o uguale salta
        mov  bx,cx             ;
        cmp  ax,0B4h           ; confronta con il valore max di elevazione
        jle  nomax             ; se minore o uguale salta
        mov  ax,0B4h           ; ripristina il valore max in elev
        mov  bx,ax
nomax:  mov dx,CS:oldel        ; carica in cx   OLD EL
        sub ax,dx              ; sottrae   ax  da cx  (elevazione attuale)
        jnc salt1              ; salta se  minore di OLDEL
        neg ax                 ; cambia segno  se negativo
salt1:  cmp ax,1               ; confronta con offset stabilito (2 gradi)
        jle usc1               ; se minore o uguale salta ad uscita1
        mov ax,bx              ; carica la nuova ELEVAZIONE in ax dal reg dx
        mov CS:oldel,ax        ; salva il valore in OLDELEVAZIONE
        mov cx,064h            ; in cx 100 decimale
        mul cx                 ; moltiplica ax per cx
        xor  dx,dx             ; azzera il registro dx
        mov cx,047h            ; in cx coeff. 360/256 (023h per 0- 90 gradi)
        div cx                 ; divide ELEV ax / cx  (047h per 0-180 gradi)
        mov dx,0308h           ; in dx indirizzo della porta di elevazione
        out dx,al              ; invia in uscita il valore di ELEVAZIONE
        jmp usc1

stopel:                        ;
        mov  dx,0308h          ; indirizzo porta
        xor  ax,0              ; azzera  ax
        out  dx,al             ; out su porta di elevazione

usc1:   pop dx                 ; pesca dx
        pop cx                 ; pesca cx
        ret                    ; ritorno
scomm1  endp
oldel   dw 0            ; returned raw elevation
oldaz   dw 064h         ; returned raw azimuth
code   ends                               ;
       end start                          ;

